// Autogenerated from Pigeon (v3.2.3), do not edit directly.
// See also: https://pub.dev/packages/pigeon
#import <Foundation/Foundation.h>
@protocol FlutterBinaryMessenger;
@protocol FlutterMessageCodec;
@class FlutterError;
@class FlutterStandardTypedData;

NS_ASSUME_NONNULL_BEGIN

@class RetrieveSecretRequest;
@class SaveSecretRequest;
@class AndroidPrompt;
@class IOsPrompt;

@interface RetrieveSecretRequest : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithKey:(NSString *)key
    androidPrompt:(AndroidPrompt *)androidPrompt
    iOsPrompt:(IOsPrompt *)iOsPrompt;
@property(nonatomic, copy) NSString * key;
@property(nonatomic, strong) AndroidPrompt * androidPrompt;
@property(nonatomic, strong) IOsPrompt * iOsPrompt;
@end

@interface SaveSecretRequest : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithKey:(NSString *)key
    secret:(NSString *)secret
    androidPrompt:(AndroidPrompt *)androidPrompt;
@property(nonatomic, copy) NSString * key;
@property(nonatomic, copy) NSString * secret;
@property(nonatomic, strong) AndroidPrompt * androidPrompt;
@end

@interface AndroidPrompt : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithTitle:(NSString *)title
    cancelLabel:(NSString *)cancelLabel
    descriptionLabel:(nullable NSString *)descriptionLabel;
@property(nonatomic, copy) NSString * title;
@property(nonatomic, copy) NSString * cancelLabel;
@property(nonatomic, copy, nullable) NSString * descriptionLabel;
@end

@interface IOsPrompt : NSObject
/// `init` unavailable to enforce nonnull fields, see the `make` class method.
- (instancetype)init NS_UNAVAILABLE;
+ (instancetype)makeWithTouchIdText:(NSString *)touchIdText;
@property(nonatomic, copy) NSString * touchIdText;
@end

/// The codec used by PigeonApi.
NSObject<FlutterMessageCodec> *PigeonApiGetCodec(void);

@protocol PigeonApi
- (void)canAuthenticateWithCompletion:(void(^)(NSNumber *_Nullable, FlutterError *_Nullable))completion;
- (void)saveRequest:(SaveSecretRequest *)request completion:(void(^)(NSNumber *_Nullable, FlutterError *_Nullable))completion;
- (void)retrieveRequest:(RetrieveSecretRequest *)request completion:(void(^)(NSString *_Nullable, FlutterError *_Nullable))completion;
- (void)deleteKey:(NSString *)key completion:(void(^)(FlutterError *_Nullable))completion;
@end

extern void PigeonApiSetup(id<FlutterBinaryMessenger> binaryMessenger, NSObject<PigeonApi> *_Nullable api);

NS_ASSUME_NONNULL_END
